# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2017-09-14 17:37
from __future__ import unicode_literals

from django.db import migrations
from uuid import uuid5, NAMESPACE_DNS

def id_from_fqdn(fqdn):
    """
    Convert an FQDN into a resource ID.
    """
    id = "dns--" + fqdn.lower().replace("-", "--").replace(".", "-")
    if len(id) > 63:
        return str(uuid5(NAMESPACE_DNS, bytes(fqdn.lower())))
    return id

def add_fqdn_aliases(apps, schema_editor):
    # Don't use any of our convenience methods here, since we're in
    # a historical context.
    Property = apps.get_model("ucs_besplusplus", "Property")
    Resource = apps.get_model("ucs_besplusplus", "Resource")
    for p in Property.objects.filter(predicate_id="fqdn"):
        Property.objects.create(subject=p.subject, predicate_id="alias",
                             object_lit=id_from_fqdn(p.object_lit))

class Migration(migrations.Migration):

    dependencies = [
        ('ucs_besplusplus', '0005_vmware-uuid-alias'),
    ]

    operations = [
        migrations.RunPython(add_fqdn_aliases)
    ]
